/*------------------------------------------------------------------------------*/
/* IrSend.h :  Copyright(C) BugMaker                                            */
/*      Version 1.00  2012.07.01 初版作成                                       */
/*      Version 1.10  2013.02.02 テーブル見直し                                 */
/*------------------------------------------------------------------------------*/
#ifndef _IrSend_h_
#define _IrSend_h_

/*------------- INCLUDE FILES ------------------------------------------*/
#include "Arduino.h"

/*------------- IrRecv/IrSend共通定義 ----------------------------------*/
#ifndef _IrTable_
#define _IrTable_

// パルス幅テーブル
#define KASE_START_H  (3200)  // -500 ～ +500
#define KASE_START_L  (1600)  // -500 ～ +500
#define KASE_DATA_H    (400)  // -100 ～ +100
#define KASE_ONE_L    (1200)  // -100 ～ +100
#define KASE_ZERO_L    (400)  // -100 ～ +100

#define NEC_START_H   (9000)  // -500 ～ +500
#define NEC_START_L   (4500)  // -500 ～ +500
#define NEC_REPEAT_L  (2250)  // -500 ～ +500
#define NEC_DATA_H     (620)  // -100 ～ +100
#define NEC_ONE_L     (1620)  // -100 ～ +100
#define NEC_ZERO_L     (500)  // -100 ～ +100

#define SONY_START_H  (2500)  // -500 ～ +500
#define SONY_DATA_L    (560)  // -100 ～ +100
#define SONY_ONE_H    (1240)  // -100 ～ +100
#define SONY_ZERO_H    (630)  // -100 ～ +100

#define GAP          (10000)

typedef enum {
	KASEIKYO, NEC, NEC_REPEAT, SONY12, SONY15, SONY20, ERROR
}	RTYPE ;

#endif


/*------------- MACROS/DEFINES -----------------------------------------*/
#define IrOnTime        (6)
#define IrOffTime       (12)

#define UStoCNT(n)    (((n/10)*38) / 100)


/*------------- TYPES --------------------------------------------------*/

class IrSend {
public:
	IrSend( byte port ) ;		// ポートの初期化
	void    write( byte *p ) ;	// 送信
private:
	void    sendKase( byte *p ) ;
	void    sendNec( byte *p ) ;
	void    sendNecRepeat( void ) ;
	void    sendSony( byte *p, byte len ) ;
	void    IrHighOut( word n ) ;	// 38KHzのnパルス(duty1/3)の点滅をする
	void    IrLowOut( word n ) ;	// 38KHzのnパルス分消灯する
	byte    led ;
} ;

#endif
