/*------------------------------------------------------------------------------*/
/* IrSendSample.ino :  Copyright(C) BugMaker                                    */
/*      Version 1.00  2012.07.07 初版作成                                       */
/*------------------------------------------------------------------------------*/
/*--------------------- INCLUDE FILES ----------------------------------*/
#include "Arduino.h"
#include "IrSend.h"

/*------------- MACROS/DEFINES -----------------------------------------*/
#define WD(a,b)		(a*256+b)
#define ToHex(c)	((c < 'A') ? (c-'0') : (c-'A'+10))


/*------------- VARIABLES ----------------------------------------------*/
IrSend	send(3) ;

int		n ;
char	str[20] ;
byte	cmd[10] ;

/*------------- PROTOTYPES ---------------------------------------------*/

/*------------- FUNCTIONS ----------------------------------------------*/
void setup()
{
  Serial.begin( 115200 ) ;
	delay( 50 ) ;
	n = 0 ;
	Serial.println( "KA nn nn nn nn nn nn : Kaseikyo format." ) ;
	Serial.println( "NE nn nn nn nn       : NEC format." ) ;
	Serial.println( "NR                   : NEC repeat code." ) ;
	Serial.println( "Sa nn 0n             : Sony 12bit format." ) ;
	Serial.println( "Sb nn nn             : Sony 15bit format." ) ;
	Serial.println( "Sc nn nn 0n          : Sony 20bit format." ) ;
}
#if 1

void loop()
{
  byte  pause[] = {SONY20, 0x19, 0x2D, 0x0F } ;
  byte  chUp[] = {KASEIKYO, 0x02, 0x20, 0x80, 0x26, 0x74, 0xD2 } ;
  byte  volUp[] = {SONY12, 0x92, 0x00 } ;

  send.write( pause ) ;
  delay( 100 ) ;
  send.write( chUp ) ;
  delay( 100 ) ;
  send.write( volUp ) ;
  
  while(1) ;
}




#else
void loop()
{
	char	c ;
	if( Serial.available() ) {
		c = Serial.read() ;
		if( ' ' < c ) {
			str[n] = c ;
			n = (n < (sizeof(str)-1)) ? n+1 : n ;
		}
		else if( c == '\n' ) {
			switch( WD(str[0],str[1]) ) {
			case WD( 'K', 'A' ):
				cmd[0] = KASEIKYO ;
				break ;

			case WD( 'N', 'E' ):	
				cmd[0] = NEC ;
				break ;

			case WD( 'N', 'R' ):
				cmd[0] = NEC_REPEAT ;
				break ;

			case WD( 'S', 'a' ):
				cmd[0] = SONY12 ;
				break ;

			case WD( 'S', 'b' ):
				cmd[0] = SONY15 ;
				break ;

			case WD( 'S', 'c' ):
				cmd[0] = SONY20 ;
				break ;
			}
			for( int j = 2 ; j < n ; j += 2 ) {
				cmd[j/2] = ToHex(str[j])*16+ToHex(str[j+1]) ;
			}
			send.write( cmd ) ;
			n = 0 ;
		}
	}
}
#endif

